<?php
require_once('Gomba/Gomba.php');
class Author extends Gomba_DB_Object {
	function configureColumns() {
		$this->addColumn('name', 'text');
		parent::configureColumns();
	}
}
class Book extends Gomba_DB_Object {
	function configureColumns() {
		$this->addColumn('title', 'text');
		$this->addColumn('author', 'gdbo:Author');
		parent::configureColumns();
	}
}

// hozzunk létre egy könyvet
$mybook = Gomba_DB_Object::create('Book', array(
	'title' => 'My First Book',
	'author' => Gomba_DB_Object::create('Author', array(
		'name' => 'Foo Fee'
	))
));
// Mi történik?
//  - Létrejön egy sor az Author táblában
//  - Létrejön egy sor a Book táblában
//  - A Book-ban lévő sor author oszlopának értéke a 
//    az Author id-jének értéke lesz

// na még egyet
$mybook2 = Gomba_DB_Object::create('Book', array(
	'title' => 'My Second Book',
	'author' => Gomba_DB_Object::create('Author', array(
		'name' => 'Foo Bar'
	))
));

// keressük ki őket
echo("---------------------\n");
echo("Rakeresek a 'My' szoval kezdodo cimekre...\n"); 
$iterator = Gomba_DB_Object::selectObjects('Book', array(
	array('title', ' LIKE ', 'My%')
));
// Mi történik?
//  - SELECT id from Book where title Like "My%"
//  - ha a tömb három elemű, akkor a harmadik elem értékét a
//    az első által meghatározott oszlop szerint formázza
//  - ha két elemű (legyen $x), akkor az megfelel
//       array($x[0], ' = ', $x[1])
//  - kapunk egy iterátort, amivel végig lehet menni az
//    eredményen

// Nézzük...
for ( ; $iterator->valid() ; $iterator->next()) {
	$item = $iterator->d(); // dereference rövidítés
	if(
		($item->get('title') != 'My First Book') &&
		($item->get('title') != 'My Second Book')
	)
		echo("selectObjects failed\n");
	else
		echo("Megtalaltam ".$item->get('title')."(".
			$item->get('author')->get('name')
			.") \n");
}

// mi van, ha konkrétan egyet akarunk kiválasztani?
$item = Gomba_DB_Object::select('Author', array(
	array('name', 'Foo Bar')
));
echo('Kerestem Foo Bar-t, id:'.$item->get('id')."\n");

// töröljük az adatbázissort, azaz takarítás
$mybook->get('author')->delete();
$mybook->delete();
$mybook2->get('author')->delete();
$mybook2->delete();        
echo("---------------------\n");
echo("Elemek torolve...\n"); 

// most is próbáljunk kiválasztani egyet
try {
	$item = Gomba_DB_Object::select('Book', array(
		array('author', 'Foo Bar')
	));
} catch (SQLException $e) {
	echo($e->getMessage()."\n");
}
?>
