<?php
require_once('Gomba/Gomba.php');
class Author extends Gomba_DB_Object 
{
	function configureColumns() 
	{
		$this->addColumn('name', 'text');
		parent::configureColumns();
	}
}
class Book extends Gomba_DB_Object 
{
	function configureColumns() 
	{
		$this->addColumn('title', 'text');
		$this->addColumn('author', 'gdbo:Author');
		parent::configureColumns();
	}
}
// a változásra figyelő osztály
class EventTest extends Gomba_Component 
{
	function __gconstruct($name, $options)
	{
		parent::__gconstruct($name, $options);
		$mybook = Gomba_DB_Object::select('Book', array(
			array('title', 'My First Book')
		));
		// a lényeg...
		$this->addEvent('onBookChanges', array(
			array($mybook->getDP('_state'), '__any__', false)
		));
	}
	
	function onBookChanges()
	{
		echo("Hey, valaki hozzanyult a Foo Fee konyvhoz\n");
	}
}

// hozzuk létre a könyvet
$mybook = Gomba_DB_Object::create('Book', array(
	'title' => 'My First Book',
	'author' => Gomba_DB_Object::create('Author', array(
		'name' => 'Foo Fee'
	))
));

// hozzuk létre az objektumot, ami figyeli a változásokat
$test = new EventTest();

// változtassuk meg az értéket
$mybook->set(array(
	'title' => 'My Modified First Book'
));

// takarítás
$mybook->get('author')->delete();
$mybook->delete();
?>